//+------------------------------------------------------------------+
//|                                                         K2.5.mq4 |
//|                                                          kwadrad |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "kwadrad"
#property link      ""

#define MAGICMA  10200603


extern double Lots                  = 0.01;
extern double MaximumRisk           = 0.6;
extern double DecreaseFactor        = 6.0;
extern double period                = 10.0;

extern double MovingShift           = 0.0;
extern double TakeProfit            = 190.0;
extern double StopLoss              = 25.0;
extern double TrailingStop          = 45.0;

//---------------------------------------------------------
int start()
  {
   if(CalculateCurrentOrders(Symbol())==0 )CheckForOpen();
                                           CheckForClose();
   return(0);
  }
//-------------------------------------------------------------------
int CalculateCurrentOrders(string symbol)
  {
   int buys=0,sells=0;
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA)
        {
         if(OrderType()==OP_BUY)  buys++;
         if(OrderType()==OP_SELL) sells++;
        }
     }
//---- return orders volume
   if(buys>0) return(buys);
   else       return(-sells);
  }
//-------------------------------------------------------------------
void CheckForOpen()                    //------ 78
  {
   int    res;
//---- go trading only for first tiks of new bar
   if(Volume[0]>1) return;
  
   double up =  iCustom    (Symbol(),0,"VininI_HMA",period,3,0,0,0);//  Blue
   double dn =  iCustom    (Symbol(),0,"VininI_HMA",period,3,0,1,0);//  Red
//---- sell conditions
   if(up<dn)  
     {
      res=OrderSend(Symbol(),OP_SELL,LotsOptimized(),Bid,3,Bid+StopLoss*Point,Bid-TakeProfit*Point,"",MAGICMA,0,Red);
      Comment ("");
      return;
     }
//---- buy conditions#include "indicators\VininI_HMA.mq4"
   if(up>dn)  
     {
      res=OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,3,Ask-StopLoss*Point,Ask+TakeProfit*Point,"",MAGICMA,0,Blue);
      Comment ("");
      return;
     }
//----
  }
  //-------------------------------------------------------------------------------
  double LotsOptimized()
  {
   double lot=Lots;
   int    orders=HistoryTotal();     // history orders total
   int    losses=0;                  // number of losses orders without a break
//---- select lot size
   lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk/1000.0,2);
//---- calcuulate number of losses orders without a break
   if(DecreaseFactor>0)
     {
      for(int i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
         //----
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) losses++;
        }
      if(losses>1) lot=NormalizeDouble(lot-lot*losses/DecreaseFactor,2);
     }
//---- return lot size
   if(lot<0.01) lot=0.01;
   return(lot);
  }
  //--------------------------------------------------------------------------
  void CheckForClose()
  {
 
//---- 
   if(Volume[0]>1) return;
//---- 
   double up =  iCustom    (Symbol(),0,"VininI_HMA",period,3,0,0,0);//  Blue
   double dn =  iCustom    (Symbol(),0,"VininI_HMA",period,3,0,1,0);//  Red
   //--------------------------------
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)        break;
      if(OrderMagicNumber()!=MAGICMA || OrderSymbol()!=Symbol()) continue;
      //---- check order type 
      if(OrderType()==OP_BUY)
        {
         if(up<dn) OrderClose(OrderTicket(),OrderLots(),Bid,3,White);
         {
         // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
         }
         break;
        }
      if(OrderType()==OP_SELL)
        {
         if(up>dn) OrderClose(OrderTicket(),OrderLots(),Ask,3,White);
         {
         // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
         }
         break;
        }
     }
//----
  }
//+------------------------------------------------------------------+